// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.
#include <inttypes.h>
#include "Random.h"

double Random::next(){
    int32_t  k,z;
    k= seed1 /53668;
    seed1 =40014*(seed1%53668)-k*12211;
    if (seed1 < 0) seed1 += 2147483563;
    k=seed2/52774;
    seed2=40692*(seed2%52774)-k*3791;
    if (seed2 < 0) seed2 += 2147483399;

    z= (seed1 - 2147483563) + seed2;
    if (z < 1) z += 2147483562;
	
    return(((double)(z))*factor);
}
